#!/usr/bin/perl -w

use strict;
#use POSIX;
#use warnings;
use XML::XPath;

use Math::Round;
use overload 'eq' => '==';
#use diagnostics;

if ($#ARGV != 1) {
print "usage: xml2bnf <input.xml> <output.il>\n";
 exit;
}

my $file = $ARGV[0];
#my $file = "test.xml";
my $xp = XML::XPath->new(filename => $file);
my @Parent;
my @Ptype;
my @GParent;
my $expr;
my @field;
my $N_Left = "./properties/property[\@name=\"Left\"]";
my $N_Top =  "./properties/property[\@name=\"Top\"]" ;
my $N_Width =  "./properties/property[\@name=\"Width\"]";
my $N_Height =  "./properties/property[\@name=\"Height\"]";
my $N_Caption =  "./properties/property[\@name=\"Caption\"]";
my $N_Text = "./properties/property[\@name=\"Text\"]";

my $P_Left = "../../../../properties/property[\@name=\"Left\"]" ;
my $P_Top = "../../../../properties/property[\@name=\"Top\"]" ;
#my $P_Width = " ";
#my $P_Height = " ";
#my $P_Caption = " ";

my $G_Left = "../../properties/property[\@name=\"Left\"]";
my $G_Top = "../../properties/property[\@name=\"Top\"]";
#my $G_Width = "../../properties/property[\@name=\"Width\"]";
#my $G_Height = "../../properties/property[\@name=\"Height\"]";
my $G_Caption = "../../properties/property[\@name=\"Caption\"]";

my $R_Left = "../../../../../../properties/property[\@name=\"Left\"]" ;
my $R_Top = "../../../../../../properties/property[\@name=\"Top\"]" ;
#my $R_Width = "../../../../../../properties/property[\@name=\"Width\"]" ;
#my $R_Height = "../../../../../../properties/property[\@name=\"Height\"]" ;
#my $R_Caption = "../../../../../../properties/property[\@name=\"Caption\"]" ;

my $outfile = $ARGV[1];
#open Form_IL_Write, ">fortest.il" or die $!;
open Form_IL_Write, ">$outfile" or die $!;

foreach my $property ($xp->find('//object[@type="TTabSheet"]')->get_nodelist) {
    my $temp = $property->find('./@name');
    push(@Parent, $temp);
}

foreach my $property ($xp->find('/object[@type="TAForm"]/components/object')->get_nodelist){
	my $temp = $property->find('./@type');
	push(@Ptype, $temp);
}

foreach my $property ($xp->find('/object[@type="TAForm"]/components/object[@type="TAGroup"]')->get_nodelist){
	my $temp = $property->find('./@name');
	push(@GParent, $temp);
}

sub formWrite
{
print Form_IL_Write "(defun CreateForm ()"."\n";

print Form_IL_Write "drain()\n";
print Form_IL_Write "form_file = \"myform.form\"\n";
print Form_IL_Write "myform = outfile(form_file \"w\")\n";
print Form_IL_Write "fprintf(myform \"#Created by xml2bnf  perl utility\\n\")\n" ;
print Form_IL_Write "fprintf(myform \"#Coded by Venkata Ramanan/Santa Clara, CA\\n\\n\")\n" ;
print Form_IL_Write "fprintf(myform \"FILE_TYPE=FORM_DEFN VERSION=2\\n\")\n";
print Form_IL_Write "fprintf(myform \"FORM AUTOGREYTEXT\\n\")"."\n";
print Form_IL_Write "fprintf(myform \"FIXED\\n\")"."\n";
print Form_IL_Write "fprintf(myform \"PORT ";

my $fw = int($xp->find('//object[@type="TAForm"]/properties/property[@name="Width"]'));
$fw = ($fw / 7);
my $fh = int($xp->find('//object[@type="TAForm"]/properties/property[@name="Height"]'));
$fh = ($fh / 10.5);

print Form_IL_Write nearest(1, $fw) . " ". nearest(1, $fh) . "\\n\")\n";

print Form_IL_Write "fprintf(myform \"". "HEADER \\\"Form Field Type Demo\\\"\\n\")\n";
#POPUP <ENUM>\"ITEM1\"\"0\",\"ITEM2\"\"1\",\"ITEM3\"\"2\",\"LAST ONE\"\"3\".
print Form_IL_Write "fprintf(myform \"POPUP <ENUM>\\\"ITEM1\\\"\\\"0\\\",\\\"ITEM2\\\"\\\"1\\\",\\\"ITEM3\\\"\\\"2\\\",\\\"LAST ONE\\\"\\\"3\\\".\\n\")"."\n";
print Form_IL_Write "fprintf(myform \"". "TILE\\n\")\n";

# Start FORM Objects Definition
#/object[@type="TAForm"]/components/object

# End FORM Objects Definition
#	Start Cut Here
 foreach my $prop($xp->find('/object[@type="TAForm"]/components/object')->get_nodelist){

	my $type = $prop->find('./@type');

	if("$type" eq "TAButton"){

		print Form_IL_Write "fprintf(myform \"". "## Button Field in FORM ## \\n\")\n";
		print Form_IL_Write "fprintf(myform \"". "FIELD " . $prop->find('./@name') . "\\n\")\n";
		my $type1 = $prop->find('../../@type');
		my $tempp = $prop->find('../../@name');
		print Form_IL_Write "fprintf(myform \"". "#Button Parent is :" . $type1."\\n\")\n";
                my $tx = int($prop->find($N_Left));
                $tx = nearest(1, ($tx / 7));
                my $ty = int($prop->find($N_Top)) ;
               	$ty = nearest(1, ($ty / 10.5));

                print Form_IL_Write "fprintf(myform \"". "FLOC " . $tx . " " . $ty . "\\n\")\n";
		print Form_IL_Write "fprintf(myform \"". "MENUBUTTON \\\"". $prop->find($N_Caption) . "\\\" ";
		
		my $nw = int($prop->find($N_Width));
		$nw = nearest(1, ($nw / 7));
		print Form_IL_Write $nw;
		print Form_IL_Write " ";
		
		
		my $nh = int($prop->find($N_Height));
		$nh = nearest(1, ($nh / 7.2));
		print Form_IL_Write $nh;

		print Form_IL_Write "\\n\")\n";
		print Form_IL_Write "fprintf(myform \"". "FGROUP \\\"" . $prop->find($G_Caption) . "\\\""."\\n\")"."\n";
		print Form_IL_Write "fprintf(myform \"ENDFIELD \\n\\n \")"."\n";


	}
	elsif("$type" eq "TAGroup"){
		#/object[@type="TAForm"]/components/object[@type="TAGroup"]//object
		$expr = "/object[\@type=\"TAForm\"]/components/object[\@type=\"TAGroup\"]//object";
		my @glist;
		foreach my $property ($xp->find($expr)->get_nodelist) {
			my $temp = $property->find('./@name');
			push(@glist, $temp);
		}
		#		print Form_IL_Write "fprintf(myform \"". "############################## "."@glist"."\\n\")\n\\n\")\n\\n\")\n\\n\")\n";

		foreach my $GParentName (@GParent) {
		    my $expr3 =  "/object[\@type=\"TAForm\"]/components/object[\@name=\"$GParentName\"]//object";
		    # print "#Debug GParent Name :".$expr3."\n";
		    my $Gleft =  "/object[\@type=\"TAForm\"]/components/object[\@name=\"$GParentName\"]/properties/property[\@name=\"Left\"]";
		    #print "#Debug GLEFT :".$Gleft."\n";
		    my $Gtop =  "/object[\@type=\"TAForm\"]/components/object[\@name=\"$GParentName\"]/properties/property[\@name=\"Top\"]";
		    #print "#Debug GTop :".$Gtop."\n";
		    my $Gwidth =  "/object[\@type=\"TAForm\"]/components/object[\@name=\"$GParentName\"]/properties/property[\@name=\"Width\"]";
		    #print "#Debug GWidth :".$Gwidth."\n";
		    my $Gheight =  "/object[\@type=\"TAForm\"]/components/object[\@name=\"$GParentName\"]/properties/property[\@name=\"Height\"]";
		    #print "#Debug GWidth :".$Gheight."\n";
		    my $Gcaption =  "/object[\@type=\"TAForm\"]/components/object[\@name=\"$GParentName\"]/properties/property[\@name=\"Caption\"]";
		    #print "#Debug GCaption :".$Gcaption."\n";

		    #print Form_IL_Write "fprintf(myform \"". "#Debug".$expr4."\\n\")\n";

		    print Form_IL_Write "fprintf(myform \"". "## Group Definition ## \\n\")\n";
		    print Form_IL_Write "fprintf(myform \"". "GROUP \\\"" . $xp->find($Gcaption) . "\\\"" . "\\n\")\n";

		    my $tx = int($xp->find(($Gleft)));
		    my $ty = int($xp->find(($Gtop)));
		    print "#Debug tx : ".$tx." ty :".$ty."\n\n";
		    print "#Debug tx : ".$tx." ty :".$ty."\n\n";
		    $tx = nearest(1, ($tx / 7));
		    $ty = nearest(1, ($ty / 10.5));

		    print Form_IL_Write "fprintf(myform \"". "GLOC ".$tx." ".$ty."\\n\")\n";

		    my $nw = int($xp->find($Gwidth));
		    my $nh = int($xp->find($Gheight));
		    $nw = nearest(1, ($nw / 7));
		    $nh = nearest(1, ($nh / 10.5));

		    print Form_IL_Write "fprintf(myform \"". "GSIZE ".$nw. " ".$nh. "\\n\")\n";
		    print Form_IL_Write "fprintf(myform \"ENDGROUP\\n\\n\")"."\n";

			foreach my $property ($xp->find($expr3)->get_nodelist) {
		    my $type = $property->find('./@type');
			if ("$type" eq "TAInput") {
	                    print Form_IL_Write "fprintf(myform \"". "## Input Field ## \\n\")\n";
	                    print Form_IL_Write "fprintf(myform \"". "FIELD " . $property->find('./@name') . "\\n\")\n";

			    my $tx = int($property->find($G_Left)) + int($property->find($N_Left));
	                    $tx = nearest(1, ($tx / 7));
	                    my $ty = int($property->find($G_Top)) + int($property->find($N_Top)) ;
	                    $ty = nearest(1, ($ty / 10.5));

	                    print Form_IL_Write "fprintf(myform \"". "FLOC " . $tx . " " . $ty . "\\n\")\n";
	                    
	                    my $nw = int($property->find($N_Width));
			    $nw = nearest(1, ($nw / 7));
			    print Form_IL_Write $nw;

	                    print Form_IL_Write "fprintf(myform \"". "STRFILLIN " . $nw . " 50\\n\")\n";
	                    print Form_IL_Write "fprintf(myform \"". "FGROUP \\\"" . $property->find($G_Caption) . "\\\""."\\n\")"."\n";
			    print Form_IL_Write "fprintf(myform \"". "VALUE \\\"" . $property->find($N_Text) . "\\\""."\\n\")"."\n";
	                    print Form_IL_Write "fprintf(myform \"ENDFIELD \\n \\n\\n\")"."\n";
			}
                elsif ("$type" eq "TAButton") {
	                        print Form_IL_Write "fprintf(myform \"". "## Button Field in TAB## \\n\")\n";
	                        print Form_IL_Write "fprintf(myform \"". "FIELD " . $property->find('./@name') . "\\n\")\n";

	                        my $type1 = $property->find('../../@type');
				my $tempp = $property->find('../../../../properties/property[@name="Caption"]');
                         	print Form_IL_Write "fprintf(myform \"". "#Button Parent is :" . $tempp . "\\n\")\n";

                            my $tx = int($property->find($G_Left)) + int($property->find($N_Left));
			    #  print Form_IL_Write "fprintf(myform \"". "#Debug G_Left :".int($property->find($G_Left))."  N_Left : ".int($property->find($N_Left))."\\n\")\n";
                            $tx = nearest(1, ($tx / 7));

                            my $ty = int($property->find($G_Top)) + int($property->find($N_Top)) ;
			    #   print Form_IL_Write "fprintf(myform \"". "#Debug G_Top :".int($property->find($G_Top))."  N_Top : ".int($property->find($N_Top))."\\n\")\n";
                            $ty = nearest(1, ($ty / 10.5));

				print Form_IL_Write "fprintf(myform \"". "FLOC " . $tx . " " . $ty . "\\n\")\n";
				print Form_IL_Write "fprintf(myform \"". "MENUBUTTON \\\"". $property->find($N_Caption) . "\\\" ";
	                        
	                        my $nw = int($property->find($N_Width));
				$nw = nearest(1, ($nw / 7));
				print Form_IL_Write $nw;

	                        print Form_IL_Write " ";
	                        my $nh = int($property->find($N_Height)) ;
				$nh = nearest(1, ($nh / 7.2));
				print Form_IL_Write $nh;

	                        print Form_IL_Write "\\n\")\n";
	                        print Form_IL_Write "fprintf(myform \"". "FGROUP \\\"" . $property->find($G_Caption) . "\\\"\\n\")"."\n";
	                        print Form_IL_Write "fprintf(myform \"ENDFIELD \\n \\n\")"."\n";
                    }
		elsif ("$type" eq "TAList") {
			    print Form_IL_Write "fprintf(myform \"". "## LIST Field in TAB## \\n\")\n";
			    print Form_IL_Write "fprintf(myform \"". "FIELD " . $property->find('./@name') . "\\n\")\n";

			    my $type1 = $property->find('../../@type');
			    my $tempp = $property->find('../../../../properties/property[@name="Caption"]');

			    print Form_IL_Write "fprintf(myform \"". "#List Parent is :" . $tempp . "\\n\")\n";

                            my $tx = int($property->find($G_Left)) + int($property->find($N_Left));
                            $tx = nearest(1, ($tx / 7));

                            my $ty = int($property->find($G_Top)) + int($property->find($N_Top)) ;
                            $ty = nearest(1, ($ty / 10.5));

			    print Form_IL_Write "fprintf(myform \"". "FLOC " . $tx . " " . $ty . "\\n\")\n";
    	                    print Form_IL_Write "fprintf(myform \"". "LIST \\\" \\\" ";

			    my $nw = int($property->find($N_Width)) ;
			    $nw = nearest(1, ($nw / 7));
			    print Form_IL_Write $nw;

			    print Form_IL_Write " ";
			    my $nh = int($property->find($N_Height));
			    $nh = nearest(1, ($nh / 20.5));
			    print Form_IL_Write $nh;
			    #print Form_IL_Write nearest(1, ((int($property->find($N_Height)) / 16)));
			    print Form_IL_Write "\\n\")\n";
			    print Form_IL_Write "fprintf(myform \"". "FGROUP \\\"" . $property->find($G_Caption) . "\\\"\\n\")"."\n";
			    print Form_IL_Write "fprintf(myform \"ENDFIELD \\n \\n\")"."\n";
			    print "#Debug Wrote List Field inside Group\n";
                    }
                elsif ("$type" eq "TALabel") {
        	                print Form_IL_Write "fprintf(myform \"". "## Text Field ## \\n\")\n";
            	            print Form_IL_Write "fprintf(myform \"". "TEXT " . "\\\"" . $property->find($N_Caption) . "\\\"" . "\\n\")\n";

                            my $tx = int($property->find($G_Left)) + int($property->find($N_Left));
                            $tx = nearest(1, ($tx / 7));
                            my $ty = int($property->find($G_Top)) + int($property->find($N_Top)) ;
                            $ty = nearest(1, ($ty / 10.5));

                            print Form_IL_Write "fprintf(myform \"". "FLOC " . $tx . " " . $ty . "\\n\")\n";
	                        print Form_IL_Write "fprintf(myform \"TGROUP \\\"".$property->find($G_Caption)."\\\"\\n\")"."\n";
    	                    print Form_IL_Write "fprintf(myform \"ENDTEXT\\n\\n\")"."\n";
                    }
                elsif ("$type" eq "TACheckbox") {
	                        print Form_IL_Write "fprintf(myform \"". "## CheckBox Field ## \\n\")\n";
	                        print Form_IL_Write "fprintf(myform \"". "FIELD " . $property->find('./@name') . "\\n\")\n";

                            my $tx = int($property->find($G_Left)) + int($property->find($N_Left));
                            my $ty = int($property->find($G_Top)) + int($property->find($N_Top)) ;
                            $ty = nearest(1, ($ty / 10.5));

                            print Form_IL_Write "fprintf(myform \"". "FLOC " . $tx . " " . $ty . "\\n\")\n";
	                        print Form_IL_Write "fprintf(myform \"". "CHECKLIST " . "\\\"" . $property->find($N_Caption) . "\\\"" . "\\n\")\n";
	                        print Form_IL_Write "fprintf(myform \"". "FGROUP \\\"" . $property->find($G_Caption) . "\\\"\\n\")"."\n";
	                        print Form_IL_Write "fprintf(myform \"ENDFIELD \\n \\n\")"."\n";
                    }
                elsif ("$type" eq "TARadio") {

	                        print Form_IL_Write "fprintf(myform \"". "## RadioButton Field ## \\n\")\n";
	                        print Form_IL_Write "fprintf(myform \"". "FIELD " . $property->find('./@name') . "\\n\")\n";

                            my $tx = int($property->find($G_Left)) + int($property->find($N_Left));
                            $tx = nearest(1, ($tx / 7));
                            my $ty = int($property->find($G_Top)) + int($property->find($N_Top)) ;
                            $ty = nearest(1, ($ty / 10.5));

                            print Form_IL_Write "fprintf(myform \"". "FLOC " . $tx . " " . $ty . "\\n\")\n";
	                        print Form_IL_Write "fprintf(myform \"". "CHECKLIST " . "\\\"" . $property->find($N_Caption) . "\\\"  \\\"rg\\\"" . "\\n\")\n";
	                        print Form_IL_Write "fprintf(myform \"". "FGROUP \\\"" . $property->find($G_Caption) . "\\\""."\\n\")"."\n";
	                        print Form_IL_Write "fprintf(myform \"ENDFIELD \\n \\n\")"."\n";

                    }
                elsif ("$type" eq "TACombo") {

                        #my @tlist;
                        #@tlist = $property->find('./properties/property[@name="Items.Strings"]/list/li[@vt="String"]/text()')   ;
                        #print Form_IL_Write "fprintf(myform \"". "$tlist[0]\\n\")\n";

	                        print Form_IL_Write "fprintf(myform \"". "## ENUM Field ## \\n\")\n";
	                        print Form_IL_Write "fprintf(myform \"". "FIELD " . $property->find('./@name') . "\\n\")\n";

                            my $tx = int($property->find($G_Left)) + int($property->find($N_Left));
                            $tx = nearest(1, ($tx / 7));
                            my $ty = int($property->find($G_Top)) + int($property->find($N_Top)) ;
                            $ty = nearest(1, ($ty / 10.5));

                            print Form_IL_Write "fprintf(myform \"". "FLOC " . $tx . " " . $ty . "\\n\")\n";
	                        print Form_IL_Write "fprintf(myform \"". "STRFILLIN ";
	                        
	                        my $nw = int($property->find($N_Width));
													$nw = nearest(1, ($nw / 7));
													print Form_IL_Write $nw;
	                        #print Form_IL_Write nearest(1, int($property->find($N_Width)) / 7);
	                        print Form_IL_Write " 50\\n\")\n";
	                        print Form_IL_Write "fprintf(myform \"". "FGROUP \\\"" . $property->find($G_Caption) . "\\\"\\n\")"."\n";
	                        print Form_IL_Write "fprintf(myform \"". "POP "."\\\""."\\\"ENUM\\\"\\n\") "."\n" ; #$property->find('./@name')."\"\\n\")\n";
	                        print Form_IL_Write "fprintf(myform \"". "ENDFIELD\\n\\n\")"."\n";
                    }
			}

		}
	}
		elsif ("$type" eq "TAList") {

			print Form_IL_Write "fprintf(myform \"". "## List Field in FORM ## \\n\")\n";
			print Form_IL_Write "fprintf(myform \"". "FIELD " . $prop->find('./@name') . "\\n\")\n";
			my $type1 = $prop->find('../../@type');
			my $tempp = $prop->find('../../properties/property[@name="Caption"]');
			print Form_IL_Write "fprintf(myform \"". "#List Parent is :" . $tempp . "\\n\")\n";
			my $tx = int($prop->find($N_Left));
			print "#Debug : ".$tx."\n";
			$tx = nearest(1, ($tx / 7));
			my $ty = int($prop->find($N_Top)) ;
			print "#Debug : ".$ty."\n";
			$ty = nearest(1, ($ty / 10.5));
			print Form_IL_Write "fprintf(myform \"". "FLOC " . $tx . " " . $ty . "\\n\")\n";

			print Form_IL_Write "fprintf(myform \"". "LIST \\\" \\\" ";
			
			my $nw = int($prop->find($N_Width));
			$nw = nearest(1, ($nw / 7));
			print Form_IL_Write $nw;
			print Form_IL_Write " ";
			
			my $nh = int($prop->find($N_Height));
			$nh = nearest(1, ($nh / 20.5));
			print Form_IL_Write $nh;

			print Form_IL_Write "\\n\")\n";
			print Form_IL_Write "fprintf(myform \"". "FGROUP \\\"" . $prop->find($G_Caption) . "\\\""."\\n\")"."\n";
			print Form_IL_Write "fprintf(myform \"ENDFIELD \\n\\n \")"."\n";
			print "#Debug Wrote List in FORM\n\n";
		}
		elsif ("$type" eq "TAInput") {
			print Form_IL_Write "fprintf(myform \"". "## Input Field ## \\n\")\n";
			print Form_IL_Write "fprintf(myform \"". "FIELD " . $prop->find('./@name') . "\\n\")\n";

			my $tx = int($prop->find($N_Left));
			$tx = nearest(1, ($tx / 7));
			my $ty = int($prop->find($N_Top)) ;
			$ty = nearest(1, ($ty / 10.5));

			print Form_IL_Write "fprintf(myform \"". "FLOC " . $tx . " " . $ty . "\\n\")\n";
			my $nw = int($prop->find($N_Width));
			$nw = nearest(1, ($nw / 7));
			#print Form_I0L_Write $nw;

			print Form_IL_Write "fprintf(myform \"". "STRFILLIN " . $nw . " 50\\n\")\n";
			print Form_IL_Write "fprintf(myform \"". "FGROUP \\\"" . $prop->find($G_Caption) . "\\\""."\\n\")"."\n";
			print Form_IL_Write "fprintf(myform \"". "VALUE \\\"" . $prop->find($N_Text) . "\\\""."\\n\")"."\n";
			print Form_IL_Write "fprintf(myform \"ENDFIELD \\n \\n\")"."\n";
		}
		elsif ("$type" eq "TALabel") {
			print Form_IL_Write "fprintf(myform \"". "## Text Field ## \\n\")\n";
			print Form_IL_Write "fprintf(myform \"". "TEXT " . "\\\"" . $prop->find($N_Caption) . "\\\"" . "\\n\")\n";

			my $tx = int($prop->find($N_Left));
			$tx = nearest(1, ($tx / 7));
			my $ty = int($prop->find($N_Top)) ;
			$ty = nearest(1, ($ty / 10.5));

			print Form_IL_Write "fprintf(myform \"". "FLOC " . $tx . " " . $ty . "\\n\")\n";
			print Form_IL_Write "fprintf(myform \"TGROUP \\\"" . $prop->find($G_Caption) . "\\\"\\n\")"."\n";
			print Form_IL_Write "fprintf(myform \"ENDTEXT\\n\\n\")"."\n";
		}
		elsif ("$type" eq "TACheckbox") {
			print Form_IL_Write "fprintf(myform \"". "## CheckBox Field ## \\n\")\n";
			print Form_IL_Write "fprintf(myform \"". "FIELD " . $prop->find('./@name') . "\\n\")\n";

			my $tx = int($prop->find($N_Left));
			$tx = nearest(1, ($tx / 7));
			my $ty = int($prop->find($N_Top)) ;
			$ty = nearest(1, ($ty / 10.5));

			print Form_IL_Write "fprintf(myform \"". "FLOC " . $tx . " " . $ty . "\\n\")\n";
			print Form_IL_Write "fprintf(myform \"". "CHECKLIST " . "\\\"" . $prop->find($N_Caption) . "\\\"" . "\\n\")\n";
			print Form_IL_Write "fprintf(myform \"". "FGROUP \\\"" . $prop->find($G_Caption) . "\\\""."\\n\")"."\n";
			print Form_IL_Write "fprintf(myform \"ENDFIELD \\n \\n\")"."\n";
		}
		elsif ("$type" eq "TARadio") {
			print Form_IL_Write "fprintf(myform \"". "## RadioButton Field ## \\n\")\n";
			print Form_IL_Write "fprintf(myform \"". "FIELD " . $prop->find('./@name') . "\\n\")\n";
    
			my $tx = int($prop->find($N_Left));
			$tx = nearest(1, ($tx / 7));
			my $ty = int($prop->find($N_Top)) ;
			$ty = nearest(1, ($ty / 10.5));
    
			print Form_IL_Write "fprintf(myform \"". "FLOC " . $tx . " " . $ty . "\\n\")\n";
			print Form_IL_Write "fprintf(myform \"". "CHECKLIST " . "\\\"" . $prop->find($N_Caption) . "\\\"  \\\"rg\\\"" . "\\n\")\n";
			print Form_IL_Write "fprintf(myform \"". "FGROUP \\\"" . $prop->find($G_Caption) . "\\\""."\\n\")"."\n";
			print Form_IL_Write "fprintf(myform \"ENDFIELD \\n \\n\")"."\n";
		}
		elsif ("$type" eq "TACombo") {

			#my @tlist;
			#@tlist = $prop->find('./properties/property[@name="Items.Strings"]/list/li[@vt="String"]/text()')   ;
			#print Form_IL_Write "fprintf(myform \"". "$tlist[0]\\n\")\n";

			print Form_IL_Write "fprintf(myform \"". "## ENUM Field ## \\n\")\n";
			print Form_IL_Write "fprintf(myform \"". "FIELD " . $prop->find('./@name') . "\\n\")\n";

			my $tx = int($prop->find($G_Left)) + int($prop->find($N_Left));
			$tx = nearest(1, ($tx / 7));
			my $ty = int($prop->find($G_Top)) + int($prop->find($N_Top)) ;
			my $ty1 = int($prop->find($R_Top)) ;
			$ty = nearest(1, ($ty / 10.5));

			print Form_IL_Write "fprintf(myform \"". "FLOC " . $tx . " " . $ty . "\\n\")\n";
			print Form_IL_Write "fprintf(myform \"". "STRFILLIN ";
			my $nw = int($prop->find($N_Width));
			$nw = nearest(1, ($nw / 7));
			print Form_IL_Write $nw;

			#print Form_IL_Write nearest(1, int($prop->find($N_Width)) / 7);
			print Form_IL_Write " 50\\n\")\n";
			print Form_IL_Write "fprintf(myform \"". "FGROUP \\\"" . $prop->find($G_Caption) . "\\\"\\n\")\n";
			print Form_IL_Write "fprintf(myform \"". "POP "."\\\""."ENUM\\\"\\n\") "."\n" ; #$property->find('./@name')."\"\\n\")\n";
			print Form_IL_Write "fprintf(myform \"". "ENDFIELD\\n\\n\")"."\n";
				}
	elsif("$type" eq "TATab"){
	    #Start TAB Objects Definition
	        print Form_IL_Write "fprintf(myform \"TABSET "."\\\"tab\\\""."\\n\")\n";
	        print Form_IL_Write "fprintf(myform \"OPTIONS tabsetDispatch\\n\")\n";

	        my $expr1;
	        my $tval;
	        $expr1 = "//object[\@name=\"" . $Parent[0] . "\"]/../../properties/property[\@name=\"Left\"]";
	        $tval  = nearest(1, (int($xp->find($expr1)) / 7));

	        print Form_IL_Write "fprintf(myform \"FLOC ".$tval. " ";

	        $expr1 = "//object[\@name=\"" . $Parent[0] . "\"]/../../properties/property[\@name=\"Top\"]";
	        $tval  = nearest(1, (int($xp->find($expr1)) / 10.5));

	        print Form_IL_Write $tval. "\\n\")\n";

	        $expr1 = "//object[\@name=\"" . $Parent[0] . "\"]/../../properties/property[\@name=\"Width\"]";
	        $tval  = nearest(1, (int($xp->find($expr1)) / 7));

	        print Form_IL_Write "fprintf(myform \"". "FSIZE " . $tval . " ";
	        $expr1 = "//object[\@name=\"" . $Parent[0] . "\"]/../../properties/property[\@name=\"Height\"]";
	        $tval  = nearest(1, (int($xp->find($expr1)) / 10.5));

	        print Form_IL_Write $tval. "\\n\")\n";

		foreach my $ParentName (@Parent) {

					#//object[@name="TabSheet1"]/.//components//properties
					$expr = "//object[\@name=\"" . $ParentName . "\"]/.//object";
					#print Form_IL_Write "fprintf(myform \"". "\\n\")\n" . "#@#@#@ XPATH Expression is : " . $expr . " #@#@#@\\n\")\n\\n\")\n";
					my $expr1 = "//object[\@name=\"" . $ParentName . "\"]/properties/property[\@name=\"Caption\"]";
                                        #print "#Debug Expression is : ".$expr1."\n";
					#print Form_IL_Write "fprintf(myform \"". "#" . $expr1 . "\\n\")\n";
					print Form_IL_Write "fprintf(myform \"TAB \\\"" .$xp->find($expr1). "\\\"\\n\")\n";

			foreach my $property ($xp->find($expr)->get_nodelist) {
					my $type = $property->find('./@type');

				if ("$type" eq "TAInput") {
					print Form_IL_Write "fprintf(myform \"". "## Input Field ## \\n\")\n";
					print Form_IL_Write "fprintf(myform \"". "FIELD " . $property->find('./@name') . "\\n\")\n";

					my $type1 = $property->find('../../@type');
					if ("$type1" eq "TTabSheet") {
						my $tx = int($property->find(($P_Left))) + int($property->find($N_Left)) - 10;
						my $ty = int($property->find(($P_Top))) + int($property->find($N_Top));
						$tx = nearest(1,($tx / 7));
						$ty = nearest(1,($ty / 10.5));
						print Form_IL_Write "fprintf(myform \"". "FLOC " . $tx . " " . $ty . "\\n\")\n";
					}
					else{
						my $tx = int($property->find($G_Left)) + int($property->find($N_Left));
						my $tx1 = int($property->find($R_Left)) ;
						$tx = $tx +$tx1;
						$tx = nearest(1, ($tx / 7));
						#	 print Form_IL_Write "fprintf(myform \"". "#@#@# ".($tx / 7)."###\\n\")\n";

						my $ty = int($property->find($G_Top)) + int($property->find($N_Top)) ;
						my $ty1 = int($property->find($R_Top)) ;
						$ty = $ty +$ty1;
						$ty = nearest(1, ($ty / 10.5));
						print Form_IL_Write "fprintf(myform \"". "FLOC " . $tx . " " . $ty . "\\n\")\n";
					}
						my $nw = int($property->find($N_Width));
						$nw = nearest(1, ($nw / 7));
						#print Form_IL_Write $nw;


						print Form_IL_Write "fprintf(myform \"". "STRFILLIN " . $nw . " 50\\n\")\n";
						print Form_IL_Write "fprintf(myform \"". "FGROUP \\\"" . $property->find($G_Caption) . "\\\""."\\n\")"."\n";
						print Form_IL_Write "fprintf(myform \"". "VALUE \\\"" . $property->find($N_Text) . "\\\""."\\n\")"."\n";
						print Form_IL_Write "fprintf(myform \"ENDFIELD \\n\\n \")"."\n";
				}
				elsif ("$type" eq "TAGroup") {
						print Form_IL_Write "fprintf(myform \"". "## Group Definition ## \\n\")\n";
						print Form_IL_Write "fprintf(myform \"". "GROUP \\\"" . $property->find($N_Caption) . "\\\"" . "\\n\")\n";

						#../../../../properties/property
                                                #print "#Debug :".$expr."\n";
						my $tx = int($property->find(($P_Left)))+int($property->find($N_Left)) - 10;
						#print "#Debug Name :".$property->find($N_Caption)."\n";
						#print "#Debug : Parent Left : ".$property->find(($P_Left))."\n";
						#print "#Debug : Node Left : ".$property->find(($N_Left))."\n";
						#print "Debug : tx : ".$tx."\n";
                                                #print "#Debug :".$P_Left."\n";
                                                #print "#Debug :".$N_Left."\n";
                                                
						my $ty = int($property->find(($P_Top)))+int($property->find($N_Top));
						#print "#Debug : Parent Top : ".$property->find(($P_Top))."\n";
						#print "#Debug : Node Top : ".$property->find(($N_Top))."\n";
						#print "Debug : ty : ".$ty."\n\n";
						#print "#Debug :".$P_Top."\n".$N_Top."\n";
                                                $tx = nearest(1, ($tx / 7));
                                                $ty = nearest(1, ($ty / 10.5));
						print Form_IL_Write "fprintf(myform \"". "GLOC ".$tx." ".$ty."\\n\")\n";

						my $nw = int($property->find($N_Width));
                                                #print "#Debug :".$N_Width."\n"."\n";
						my $nh = int($property->find($N_Height));
						$nw = nearest(1, ($nw / 7));
						$nh = nearest(1, ($nh / 10.5));
						print Form_IL_Write "fprintf(myform \"". "GSIZE ".$nw. " ".$nh. "\\n\")\n";
						print Form_IL_Write "fprintf(myform \"ENDGROUP\\n\\n\")"."\n";
					}
				elsif ("$type" eq "TAButton") {
						print Form_IL_Write "fprintf(myform \"". "## Button Field in TAB## \\n\")\n";
						print Form_IL_Write "fprintf(myform \"". "FIELD " . $property->find('./@name') . "\\n\")\n";

						my $type1 = $property->find('../../@type');

						if ("$type1" eq "TTabSheet") {
							my $tempp = $property->find('../../../../properties/property[@name="Caption"]');
							print Form_IL_Write "fprintf(myform \"". "#Button Parent is :" . $tempp . "\\n\")\n";
							my $tx = int($property->find(($P_Left))) + int($property->find($N_Left)) - 10;
							my $ty = int($property->find(($P_Top))) + int($property->find($N_Top));
							$tx = nearest(1,($tx / 7));
							#print Form_IL_Write "fprintf(myform \"". "#".$tx."\\n\")\n";
							$ty = nearest(1,($ty / 10.5));
							#print Form_IL_Write "fprintf(myform \"". "#".$ty."\\n\")\n";
							print Form_IL_Write "fprintf(myform \"". "FLOC " . $tx . " " . $ty . "\\n\")\n";
						}
						else {
							my $tempp = $property->find('../../../../properties/property[@name="Caption"]');
							print Form_IL_Write "fprintf(myform \"". "#Button Parent is :" . $tempp . "\\n\")\n";
							my $tx = int($property->find($G_Left)) + int($property->find($N_Left));
							my $tx1 = int($property->find($R_Left)) ;
							$tx = $tx +$tx1;
							$tx = nearest(1, ($tx / 7));
							#  print Form_IL_Write "fprintf(myform \"". "#@#@# ".($tx / 7)."###\\n\")\n";

							my $ty = int($property->find($G_Top)) + int($property->find($N_Top)) ;
							my $ty1 = int($property->find($R_Top)) ;
							$ty = $ty +$ty1;
							$ty = nearest(1, ($ty / 10.5));
							print Form_IL_Write "fprintf(myform \"". "FLOC " . $tx . " " . $ty . "\\n\")\n";
						}

				            print Form_IL_Write "fprintf(myform \"". "MENUBUTTON \\\"". $property->find($N_Caption) . "\\\" ";
							my $nw = int($property->find($N_Width));
							$nw = nearest(1, ($nw / 7));
							print Form_IL_Write $nw;

							print Form_IL_Write " ";
							my $nh = int($property->find($N_Height)) ;
							$nh = nearest(1, ($nh / 7.2));
							print Form_IL_Write $nh;

							print Form_IL_Write "\\n\")\n";
							print Form_IL_Write "fprintf(myform \"". "FGROUP \\\"" . $property->find($G_Caption) . "\\\""."\\n\")"."\n";
							print Form_IL_Write "fprintf(myform \"ENDFIELD \\n \\n\")"."\n";
					}

					elsif ("$type" eq "TAList") {
						print Form_IL_Write "fprintf(myform \"". "## List Field in TAB## \\n\")\n";
						print Form_IL_Write "fprintf(myform \"". "FIELD " . $property->find('./@name') . "\\n\")\n";

							my $type1 = $property->find('../../@type');

						if ("$type1" eq "TTabSheet") {
							my $tempp = $property->find('../../properties/property[@name="Caption"]');
							print Form_IL_Write "fprintf(myform \"". "#List Parent is :" . $tempp . "\\n\")\n";
							my $tx = int($property->find(($P_Left))) + int($property->find($N_Left)) - 10;
							my $ty = int($property->find(($P_Top))) + int($property->find($N_Top));
							$tx = nearest(1,($tx / 7));
							$ty = nearest(1,($ty / 10.5));
							print Form_IL_Write "fprintf(myform \"". "FLOC " . $tx . " " . $ty . "\\n\")\n";
						}
						else {
							my $tempp = $property->find('../../../../properties/property[@name="Caption"]');
							print Form_IL_Write "fprintf(myform \"". "#List Parent is :" . $tempp . "\\n\")\n";
							my $tx = int($property->find($G_Left)) + int($property->find($N_Left));
							my $tx1 = int($property->find($R_Left)) ;
							$tx = $tx +$tx1;
							$tx = nearest(1, ($tx / 7));
							my $ty = int($property->find($G_Top)) + int($property->find($N_Top)) ;
							my $ty1 = int($property->find($R_Top)) ;
							$ty = $ty +$ty1;
							$ty = nearest(1, ($ty / 10.5));
							print Form_IL_Write "fprintf(myform \"". "FLOC " . $tx . " " . $ty  . "\\n\")\n";
						}
							print Form_IL_Write "fprintf(myform \"". "LIST \\\" \\\" ";
							my $nw = int($property->find($N_Width));
							$nw = nearest(1, ($nw / 7));
							print Form_IL_Write $nw;

							print Form_IL_Write " ";

							my $nh = int($property->find($N_Height));
							$nh = nearest(1, ($nh / 20.5));
							print Form_IL_Write $nh;

							#print Form_IL_Write nearest(1, ((int($property->find($N_Height)) / 16)));
							print Form_IL_Write "\\n\")\n";
							print Form_IL_Write "fprintf(myform \"". "FGROUP \\\"" . $property->find($G_Caption) . "\\\""."\\n\")"."\n";
							print Form_IL_Write "fprintf(myform \"ENDFIELD \\n \\n\")"."\n";
							print "#Debug Wrote List in TAB\n";
					}

				elsif ("$type" eq "TALabel") {
						print Form_IL_Write "fprintf(myform \"". "## Text Field ## \\n\")\n";
						print Form_IL_Write "fprintf(myform \"". "TEXT " . "\\\"" . $property->find($N_Caption) . "\\\"" . "\\n\")\n";

							my $type1 = $property->find('../../@type');
						if ("$type1" eq "TTabSheet") {
							my $tx = int($property->find(($P_Left))) + int($property->find($N_Left)) - 10;
							my $ty = int($property->find(($P_Top))) + int($property->find($N_Top));
							$tx = nearest(1,($tx / 7));
							$ty = nearest(1,($ty / 10.5));
							print Form_IL_Write "fprintf(myform \"". "FLOC " . $tx . " " . $ty . "\\n\")\n";
						}
						else {
							my $tx = int($property->find($G_Left)) + int($property->find($N_Left));
							my $tx1 = int($property->find($R_Left)) ;
							$tx = $tx +$tx1;
							$tx = nearest(1, ($tx / 7));
							# print Form_IL_Write "fprintf(myform \"". "#@#@# ".($tx / 7)."###\\n\")\n";

							my $ty = int($property->find($G_Top)) + int($property->find($N_Top)) ;
							my $ty1 = int($property->find($R_Top)) ;
							$ty = $ty +$ty1;
							$ty = nearest(1, ($ty / 10.5));
							print Form_IL_Write "fprintf(myform \"". "FLOC " . $tx . " " . $ty . "\\n\")\n";
						}

						print Form_IL_Write "fprintf(myform \"TGROUP \\\"" . $property->find($G_Caption) . "\\\"\\n\")"."\n";
						print Form_IL_Write "fprintf(myform \"ENDTEXT\\n\\n\")"."\n";
					}
				elsif ("$type" eq "TACheckbox") {
						print Form_IL_Write "fprintf(myform \"". "## CheckBox Field ## \\n\")\n";
						print Form_IL_Write "fprintf(myform \"". "FIELD " . $property->find('./@name') . "\\n\")\n";

							my $type1 = $property->find('../../@type');
						if ("$type1" eq "TTabSheet") {
							my $tx = int($property->find(($P_Left))) + int($property->find($N_Left)) - 10;
							my $ty = int($property->find(($P_Top))) + int($property->find($N_Top));
							$tx = nearest(1,($tx / 7));
							$ty = nearest(1,($ty / 10.5));
							print Form_IL_Write "fprintf(myform \"". "FLOC " . $tx . " " . $ty . "\\n\")\n";
						}
						else {
							my $tx = int($property->find($G_Left)) + int($property->find($N_Left));
							my $tx1 = int($property->find($R_Left)) ;
							$tx = $tx +$tx1;
							$tx = nearest(1, ($tx / 7));
							#	                print Form_IL_Write "fprintf(myform \"". "#@#@# ".($tx / 7)."###\\n\")\n";

							my $ty = int($property->find($G_Top)) + int($property->find($N_Top)) ;
							my $ty1 = int($property->find($R_Top)) ;
							$ty = $ty +$ty1;
							$ty = nearest(1, ($ty / 10.5));
							print Form_IL_Write "fprintf(myform \"". "FLOC " . $tx . " " . $ty . "\\n\")\n";
						}

						print Form_IL_Write "fprintf(myform \"". "CHECKLIST " . "\\\"" . $property->find($N_Caption) . "\\\"" . "\\n\")\n";
						print Form_IL_Write "fprintf(myform \"". "FGROUP \\\"" . $property->find($G_Caption) . "\\\"\\n\")"."\n";
						print Form_IL_Write "fprintf(myform \"ENDFIELD \\n \\n\")"."\n";
				}
				elsif ("$type" eq "TARadio") {
						print Form_IL_Write "fprintf(myform \"". "## RadioButton Field ## \\n\")\n";
						print Form_IL_Write "fprintf(myform \"". "FIELD " . $property->find('./@name') . "\\n\")\n";

							my $type1 = $property->find('../../@type');
						if ("$type1" eq "TTabSheet") {
							my $tx = int($property->find(($P_Left))) + int($property->find($N_Left)) - 10;
							my $ty = int($property->find(($P_Top))) + int($property->find($N_Top));
							$tx = nearest(1,($tx / 7));
							$ty = nearest(1,($ty / 10.5));
							print Form_IL_Write "fprintf(myform \"". "FLOC " . $tx . " " . $ty . "\\n\")\n";
						}
						else {
							my $tx = int($property->find($G_Left)) + int($property->find($N_Left));
							my $tx1 = int($property->find($R_Left)) ;
							$tx = $tx +$tx1;
							$tx = nearest(1, ($tx / 7));
							#	                print Form_IL_Write "fprintf(myform \"". "#@#@# ".($tx / 7)."###\\n\")\n";

							my $ty = int($property->find($G_Top)) + int($property->find($N_Top)) ;
							my $ty1 = int($property->find($R_Top)) ;
							$ty = $ty +$ty1;
							$ty = nearest(1, ($ty / 10.5));
							print Form_IL_Write "fprintf(myform \"". "FLOC " . $tx . " " . $ty . "\\n\")\n";
						}

						print Form_IL_Write "fprintf(myform \"". "CHECKLIST " . "\\\"" . $property->find($N_Caption) . "\\\"  \\\"rg\\\"" . "\\n\")\n";
						print Form_IL_Write "fprintf(myform \"". "FGROUP \\\"" . $property->find($G_Caption) . "\\\""."\\n\")"."\n";
						print Form_IL_Write "fprintf(myform \"ENDFIELD \\n \\n\")"."\n";

					}
				elsif ("$type" eq "TACombo") {

							#my @tlist;
							#@tlist = $property->find('./properties/property[@name="Items.Strings"]/list/li[@vt="String"]/text()')   ;
							#print Form_IL_Write "fprintf(myform \"". "$tlist[0]\\n\")\n";

							print Form_IL_Write "fprintf(myform \"". "## ENUM Field ## \\n\")\n";
							print Form_IL_Write "fprintf(myform \"". "FIELD " . $property->find('./@name') . "\\n\")\n";

							my $type1 = $property->find('../../@type');
						if ("$type1" eq "TTabSheet") {
							my $tx = int($property->find(($P_Left)) ) + int($property->find($N_Left)) - 10;
							my $ty = int($property->find(($P_Top))) + int($property->find($N_Top));
							$tx = nearest(1,($tx / 7));
							$ty = nearest(1,($ty / 10.5));
							print Form_IL_Write "fprintf(myform \"". "FLOC " . $tx . " " . $ty . "\\n\")\n";
						}
						else {
							my $tx = int($property->find($G_Left)) + int($property->find($N_Left));
							my $tx1 = int($property->find($R_Left)) ;
							$tx = $tx +$tx1;
							$tx = nearest(1, ($tx / 7));
								#	                print Form_IL_Write "fprintf(myform \"". "#@#@# ".($tx / 7)."###\\n\")\n";

							my $ty = int($property->find($G_Top)) + int($property->find($N_Top)) ;
							my $ty1 = int($property->find($R_Top)) ;
							$ty = $ty +$ty1;
							$ty = nearest(1, ($ty / 10.5));
							print Form_IL_Write "fprintf(myform \"". "FLOC " . $tx . " " . $ty . "\\n\")\n";
						}
							print Form_IL_Write "fprintf(myform \"". "STRFILLIN ";
							my $nw = int($property->find($N_Width));
							$nw = nearest(1, ($nw / 7));
							print Form_IL_Write $nw;

							
							#print Form_IL_Write nearest(1, int($property->find($N_Width)) / 7);
							print Form_IL_Write " 50\\n\")\n";
							print Form_IL_Write "fprintf(myform \"". "FGROUP \\\"" . $property->find($G_Caption) . "\\\"\\n\")"."\n";

							print Form_IL_Write "fprintf(myform \"". "POP "."\\\""."ENUM\\\"\\n\") "."\n" ; #$property->find('./@name')."\"\\n\")\n";
							print Form_IL_Write "fprintf(myform \"". "ENDFIELD\\n\\n\")"."\n";
				}

			}
				print Form_IL_Write "fprintf(myform \"". "ENDTAB\\n\\n\")\n";
		}

		print Form_IL_Write "fprintf(myform \"". "ENDTABSET\\n\\n\")\n";
		# End TAB Objects Definition
	}
}


#	Endt Cut Here
#print Form_IL_Write "fprintf(myform \"FLEXMODE edgegravity\\n\\n\")"."\n";
print Form_IL_Write "fprintf(myform \"ENDTILE\\n\\n\")"."\n";
print Form_IL_Write "fprintf(myform \"ENDFORM\\n\\n\")"."\n\n";
print Form_IL_Write "close(myform)\n";
print Form_IL_Write ")"."\n\n\n";
}

sub formAction
{
	print Form_IL_Write "(defun Form_Action (myform)\n";
	print Form_IL_Write "(let (t1 item index field cnt)";
	print Form_IL_Write "(printf \"field/value %L = %L (int %L\\n)\" \n";
	print Form_IL_Write "myform->curField myform->curValue, myform->curValueInt )\n";
	print Form_IL_Write "(printf \"doneState %L\\n\" myform->doneState )\n";
	print Form_IL_Write "case(myform->curField\n";
foreach my $property ($xp->find('//object')->get_nodelist) {
    my $temp = $property->find('./@type');
    push(@field, $temp);

    if("$temp" eq "TAInput"){
	print Form_IL_Write "\t\t(\"".$property->find('./@name')."\"\n\n";
	print Form_IL_Write "\t\t;Input Field \n";
	print Form_IL_Write "\t\t;Enter Action Here\n";
	print Form_IL_Write "\t\t\n\t\t)\n";
    }
    elsif("$temp" eq "TAButton"){
	print Form_IL_Write "\t\t(\"".$property->find('./@name')."\"\n\n";
	print Form_IL_Write "\t\t;Button Field \n";
	print Form_IL_Write "\t\t;Enter Action Here\n";
	print Form_IL_Write "\t\t\n\t\t)\n";
    }
    elsif("$temp" eq "TACheckbox"){
        print Form_IL_Write "\t\t(\"".$property->find('./@name')."\"\n\n";
	print Form_IL_Write "\t\t;CheckBox Field \n";
	print Form_IL_Write "\t\t;Enter Action Here\n";
	print Form_IL_Write "\t\t\n\t\t)\n";
    }
    elsif("$temp" eq "TARadio"){
	print Form_IL_Write "\t\t(\"".$property->find('./@name')."\"\n\n";
	print Form_IL_Write "\t\t;Radio Field \n";
	print Form_IL_Write "\t\t;Enter Action Here\n";
	print Form_IL_Write "\t\t\n\t\t)\n";
    }
    elsif("$temp" eq "TACombo"){
	print Form_IL_Write "\t\t(\"".$property->find('./@name')."\"\n\n";
	print Form_IL_Write "\t\t;Combo Field \n";
	print Form_IL_Write "\t\t;Enter Action Here\n";
	print Form_IL_Write "\t\t\n\t\t)\n";
    }
elsif("$temp" eq "TAList"){
	print Form_IL_Write "\t\t(\"".$property->find('./@name')."\"\n\n";
	print Form_IL_Write "\t\t;List Field \n";
	print Form_IL_Write "\t\t;Enter Action Here\n";
	print Form_IL_Write "\t\t\n\t\t)\n";
    }
}

print Form_IL_Write "\t)\n"."\t";
print Form_IL_Write "\t)\n"."\n";
print Form_IL_Write "if((nequal myform->doneState 0)"."\n";
print Form_IL_Write "axlFormClose(myform))"."\n";
print Form_IL_Write ")\n";
}

sub MainFormFunction{
    #fw = axlFormCreate('f1s "axlform" position '_afCallback t nil )
	print Form_IL_Write "/*Created by xml2bnf  perl utility\n" ;
	print Form_IL_Write "Coded by Venkata Ramanan/Sant Clara, CA\n" ;
	print Form_IL_Write "Version History*/"."\n\n" ;
	print Form_IL_Write " ; WARRANTY:\n";
	print Form_IL_Write " ; NONE. NONE. NONE.\n";

	print Form_IL_Write "(defun my_form ()\n";
	print Form_IL_Write "\t\t\ttime = getCurrentTime()\n";
	print Form_IL_Write "\t\t\ttime = parseString(time)\n";
	print Form_IL_Write "\t\t\tday = nth(1 time)\n";
	print Form_IL_Write "\t\t\tmonth = car(time)\n";
	print Form_IL_Write "\t\t\tmonth = upperCase(month)\n";
	print Form_IL_Write "\t\t\tyear = nth(3 time)\n";
	print Form_IL_Write "\t\t\tdate = strcat(\" Date: \" day \" \" month \" \" year)\n";

	print Form_IL_Write "\t\t\t CreateForm()\n";
	print Form_IL_Write "\t\t\tmyform=axlFormCreate( (gensym) form_file nil 'Form_Action t)\n";
	print Form_IL_Write "\t\t\taxlFormDisplay(myform)\n";
	print Form_IL_Write "\t\t\taxlUIWPrint(myform date)\n\n";
	print Form_IL_Write "\t\t)\n\n\n";

}
&MainFormFunction;
&formWrite;
&formAction;
close Form_IL_Write;
